default.hook <- function(reg,handle,index,data){
  .DATA<<-data
  .INDEX<<-index
  .HANDLE<<-handle
  .REG<<-reg
}

default.figure.startup<-function(...){
}

default.annotation <- function(reg,handle,index,data){
  grid.edit(handle$name,x=unit(reg[1,2],"native"),y=unit(reg[2,2],"native"),redraw=T)
}

delete.in.range<- function(reg,handle,index,datainreg){
#   if (length(index)>0){
      xd <- grid.get(handle$name)$x
      yd <- grid.get(handle$name)$y
      grid.edit(handle$name,x=xd[-index],y=yd[-index],redraw=T)
#   }
}

lf.in.range <- function(reg,handle,index,datainreg){
  library(stats)
  Y <- cbind(datainreg[,1],1)
  is.na(Y[,1])->l
  Y <- Y[!l,]
  x <- range(Y[,1])
  y <- datainreg[!l,2]
  x <- c(x[1]-(x[2]-x[1])/2,x[2]+(x[2]-x[1])/2)
  lf<-lm.fit(Y,y)
  .LF<<-lf$coefficients
  ggplot(x=x,y=cbind(x,1)%*%lf$coefficients,Elabel=paste(c("Ax+B: A=","B="),lf$coefficients,collapse=" ",sep=""),gp=gpar(col="blue"),rescale=F)
}

sort.data <- function(reg,handle,index,data){
   l <- sort(data[,1],index.return=TRUE)   
   grid.edit(handle$name,x=data[l$ix,1],y=data[l$ix,2],redraw=TRUE)
}

move.indexed <- function(reg,handle,index,data){
  xd <- grid.get(handle$name)$x
  yd <- grid.get(handle$name)$y
  xd[index] <- xd[index]+reg[1,2]-reg[1,1]
  yd[index] <- yd[index]+reg[2,2]-reg[2,1]
  grid.edit(handle$name,x=xd,y=yd,redraw=TRUE)
}

move.indexed.y <- function(reg,handle,index,data){
  yd <- grid.get(handle$name)$y
  yd[index] <- yd[index]+reg[2,2]-reg[2,1]
  grid.edit(handle$name,y=yd,redraw=TRUE)
}

smooth.data <- function(reg,handle,index,data){
  library(stats)
  ksmooth(x=data[,1],y=data[,2],kernel="normal",bandwidth=3)->z
  ggplot(x=z$x,y=z$y,Elabel=paste(handle$title,"smoothed"),gp=gpar(col="blue"),rescale=FALSE)
}
  
spline.data <- function(reg,handle,index,data){
  library(stats)
  if(dim(data)[[1]]>4){
    z <- smooth.spline(x=data[,1],y=data[,2],spar=0.6,all.knots=T)
    sfun<-splinefun(z$x,z$y)
    xdata <- seq(range(data[,1])[[1]],range(data[,1])[[2]],length=250)
    ggplot(x=xdata,y=sfun(xdata),Elabel="Smooth spline",gp=gpar(col="red"),rescale=F)
  } 
}

spline.points <- function(reg,handle,index,data){
  library(stats)
  if (dim(data)[[1]]==1){
    .SPLINE<<-ggplot(x=data[1,1],y=data[1,2],Elabel=paste("Smooth spline for",handle$title),rescale=FALSE,gp=gpar(col="red"))
  }else{
    if(dim(data)[[1]]>4){
      z <- smooth.spline(x=data[,1],y=data[,2],spar=0.6,all.knots=T)
      sfun<-splinefun(z$x,z$y)
      xdata <- seq(range(data[,1])[[1]],range(data[,1])[[2]],length=250)
      grid.edit(.SPLINE$name,x=xdata,y=sfun(xdata))
    } else {
       grid.edit(.SPLINE$name,x=data[,1],y=data[,2])
    }
  }
}


default.hooks <- function(){
  on.select.annotation <<- default.annotation
  on.select.element <<- default.hook
  on.select.region <<- default.hook
  on.select.points <<- default.hook
}

