\name{grid.scale}
\alias{grid.scale}
\title{Draw Tick Marks, Labels and Titles for Horizontal or Vertical Axes.}
\description{
  This function draws panel's axis.
}
\usage{
grid.scale(at="", legend="", type="b", inward=FALSE, grilled=FALSE,
gp=gpar(lwd = 2, fontsize = 12, fontface = 1), draw=TRUE, vp=NULL)
}

\arguments{
  \item{at}{
    Character string containing the code used to calculate tick marks
    position and tick marks' labels. If \code{at} is empty, tick marks
    are evenly distributed along axis at position with "pretty numbers"
    (see \code{\link[grid]{grid.pretty}}). Otherwise \code{at} are
    parsed and evaluated twice in environment with two local variables
    \code{RANGE} and \code{TICK.LAB} set. \code{RANGE} contains the current
    range of the axis. \code{TICK.LAB} is set either to "tick" or
    "label". In the former case, if \code{at} string is evaluated to
    numerical vector, then this values are used as a positions of tick
    marks; in the latter case the value may be numerical or character
    vector which gives tick marks' labels (tips
    of the day: \code{at="Inf"} draws an empty axis without ticks and
    labels; \code{at="list(tick=0,label=\"Start point\")[[TICK.LAB]]"} draws
    only one tick at point zero with label "Start point";
    \code{at="log10.ticks(RANGE,TICK.LAB)"} makes automatic logariphmic axis with
    power of 10 labels).
  }
  \item{legend}{
    Axis title. Can be either character string or expression. If entered
    in GUI text box in former case the value must be quoted, in the
    latter case it mustn't be quoted.
  }
  \item{type}{
    side of the plot to draw axis on. Can be either
    \code{"b"},\code{"t"},\code{"l"},\code{"r"} - for bottom, top, left or
    right axis.
    }
  \item{inward}{
    Direction of tick marks. If \code{TRUE} tick marks are drawn inward
    plotting area, otherwise - overwise.
  }
  \item{grilled}{
    To draw or not to draw grids. Grid are always drawn with 1pt wide
    dashed gray lines.
    }
  \item{gp}{
    Graphic parameter of axis. Actually this is graphic
    properties of axis legend only. Tick marks are always drawn with 2pt
    wide black lines and theirs labels are always drawn with default font
    style and size.
  }
  \item{vp,draw}{
    Standard grob's parameters - viewport to draw onto and does this
    function actually
    draw the graphic object or not.
    }
}


\value{
  Grob (GRaphic OBject, see \code{\link[grid]{grid.grob}}) of class "grid.scale".   
   }  
}

\details{
  This grob is deprecated since version 0.3-0. Although it is still in
  the package code but is not used internally no more. See
  \code{\link{grid.plotarea}} which is (roughly speaking) a concatenation of four
  grid.scale grobs.
  }

\references{
}
\seealso{
  \code{\link[grid]{gpar}},  \code{\link[grid]{viewport}}, \code{\link{grid.plotarea}}
}
\author{M.Kondrin}
\keyword{hplot}
\keyword{iplot}
\keyword{dynamic}
